diff --git a/src/backend/commands/comment.c b/src/backend/commands/comment.c
index caacb17e5d7..678cf3320ed 100644
--- a/src/backend/commands/comment.c
+++ b/src/backend/commands/comment.c
@@ -147,10 +147,9 @@ CreateComments(Oid oid, Oid classoid, int32 subid, const char *comment)
 	SysScanDesc sd;
 	HeapTuple	oldtuple;
 	HeapTuple	newtuple = NULL;
-	Datum		values[Natts_pg_description];
-	bool		nulls[Natts_pg_description];
-	bool		replaces[Natts_pg_description];
-	int			i;
+	Datum		values[Natts_pg_description] = {0};
+	bool		nulls[Natts_pg_description] = {false};
+	Bitmapset  *updated = NULL;
 
 	/* Reduce empty-string to NULL case */
 	if (comment != NULL && strlen(comment) == 0)
@@ -159,15 +158,10 @@ CreateComments(Oid oid, Oid classoid, int32 subid, const char *comment)
 	/* Prepare to form or update a tuple, if necessary */
 	if (comment != NULL)
 	{
-		for (i = 0; i < Natts_pg_description; i++)
-		{
-			nulls[i] = false;
-			replaces[i] = true;
-		}
-		values[Anum_pg_description_objoid - 1] = ObjectIdGetDatum(oid);
-		values[Anum_pg_description_classoid - 1] = ObjectIdGetDatum(classoid);
-		values[Anum_pg_description_objsubid - 1] = Int32GetDatum(subid);
-		values[Anum_pg_description_description - 1] = CStringGetTextDatum(comment);
+		HeapTupleUpdateValue(pg_description, objoid, ObjectIdGetDatum(oid), values, nulls, updated);
+		HeapTupleUpdateValue(pg_description, classoid, ObjectIdGetDatum(classoid), values, nulls, updated);
+		HeapTupleUpdateValue(pg_description, objsubid, Int32GetDatum(subid), values, nulls, updated);
+		HeapTupleUpdateValue(pg_description, description, CStringGetTextDatum(comment), values, nulls, updated);
 	}
 
 	/* Use the index to search for a matching old tuple */
@@ -198,9 +192,9 @@ CreateComments(Oid oid, Oid classoid, int32 subid, const char *comment)
 			CatalogTupleDelete(description, &oldtuple->t_self);
 		else
 		{
-			newtuple = heap_modify_tuple(oldtuple, RelationGetDescr(description), values,
-										 nulls, replaces);
-			CatalogTupleUpdate(description, &oldtuple->t_self, newtuple);
+			HeapTupleUpdateValue(pg_description, description, CStringGetTextDatum(comment), values, nulls, updated);
+			newtuple = heap_update_tuple(oldtuple, RelationGetDescr(description), values, nulls, updated);
+			CatalogTupleUpdate(description, &oldtuple->t_self, newtuple, updated, NULL);
 		}
 
 		break;					/* Assume there can be only one match */
@@ -214,7 +208,7 @@ CreateComments(Oid oid, Oid classoid, int32 subid, const char *comment)
 	{
 		newtuple = heap_form_tuple(RelationGetDescr(description),
 								   values, nulls);
-		CatalogTupleInsert(description, newtuple);
+		CatalogTupleInsert(description, newtuple, NULL);
 	}
 
 	if (newtuple != NULL)
@@ -223,6 +217,7 @@ CreateComments(Oid oid, Oid classoid, int32 subid, const char *comment)
 	/* Done */
 
 	table_close(description, NoLock);
+	bms_free(updated);
 }
 
 /*
@@ -242,9 +237,9 @@ CreateSharedComments(Oid oid, Oid classoid, const char *comment)
 	SysScanDesc sd;
 	HeapTuple	oldtuple;
 	HeapTuple	newtuple = NULL;
-	Datum		values[Natts_pg_shdescription];
-	bool		nulls[Natts_pg_shdescription];
-	bool		replaces[Natts_pg_shdescription];
+	Datum		values[Natts_pg_shdescription] = {0};
+	bool		nulls[Natts_pg_shdescription] = {false};
+	Bitmapset  *updated = NULL;
 	int			i;
 
 	/* Reduce empty-string to NULL case */
@@ -257,11 +252,10 @@ CreateSharedComments(Oid oid, Oid classoid, const char *comment)
 		for (i = 0; i < Natts_pg_shdescription; i++)
 		{
 			nulls[i] = false;
-			replaces[i] = true;
 		}
-		values[Anum_pg_shdescription_objoid - 1] = ObjectIdGetDatum(oid);
-		values[Anum_pg_shdescription_classoid - 1] = ObjectIdGetDatum(classoid);
-		values[Anum_pg_shdescription_description - 1] = CStringGetTextDatum(comment);
+		HeapTupleUpdateValue(pg_shdescription, objoid, ObjectIdGetDatum(oid), values, nulls, updated);
+		HeapTupleUpdateValue(pg_shdescription, classoid, ObjectIdGetDatum(classoid), values, nulls, updated);
+		HeapTupleUpdateValue(pg_shdescription, description, CStringGetTextDatum(comment), values, nulls, updated);
 	}
 
 	/* Use the index to search for a matching old tuple */
@@ -288,9 +282,9 @@ CreateSharedComments(Oid oid, Oid classoid, const char *comment)
 			CatalogTupleDelete(shdescription, &oldtuple->t_self);
 		else
 		{
-			newtuple = heap_modify_tuple(oldtuple, RelationGetDescr(shdescription),
-										 values, nulls, replaces);
-			CatalogTupleUpdate(shdescription, &oldtuple->t_self, newtuple);
+			HeapTupleUpdateValue(pg_shdescription, description, CStringGetTextDatum(comment), values, nulls, updated);
+			newtuple = heap_update_tuple(oldtuple, RelationGetDescr(shdescription), values, nulls, updated);
+			CatalogTupleUpdate(shdescription, &oldtuple->t_self, newtuple, updated, NULL);
 		}
 
 		break;					/* Assume there can be only one match */
@@ -304,7 +298,7 @@ CreateSharedComments(Oid oid, Oid classoid, const char *comment)
 	{
 		newtuple = heap_form_tuple(RelationGetDescr(shdescription),
 								   values, nulls);
-		CatalogTupleInsert(shdescription, newtuple);
+		CatalogTupleInsert(shdescription, newtuple, NULL);
 	}
 
 	if (newtuple != NULL)
@@ -313,6 +307,7 @@ CreateSharedComments(Oid oid, Oid classoid, const char *comment)
 	/* Done */
 
 	table_close(shdescription, NoLock);
+	bms_free(updated);
 }
 
 /*
diff --git a/src/backend/commands/dbcommands.c b/src/backend/commands/dbcommands.c
index 87949054f26..2d18d1fad22 100644
--- a/src/backend/commands/dbcommands.c
+++ b/src/backend/commands/dbcommands.c
@@ -702,8 +702,8 @@ createdb(ParseState *pstate, const CreatedbStmt *stmt)
 	volatile Oid dst_deftablespace;
 	Relation	pg_database_rel;
 	HeapTuple	tuple;
-	Datum		new_record[Natts_pg_database] = {0};
-	bool		new_record_nulls[Natts_pg_database] = {0};
+	Datum		values[Natts_pg_database] = {0};
+	bool		nulls[Natts_pg_database] = {false};
 	Oid			dboid = InvalidOid;
 	Oid			datdba;
 	ListCell   *option;
@@ -1457,45 +1457,44 @@ createdb(ParseState *pstate, const CreatedbStmt *stmt)
 		   (dblocprovider == COLLPROVIDER_LIBC && !dblocale));
 
 	/* Form tuple */
-	new_record[Anum_pg_database_oid - 1] = ObjectIdGetDatum(dboid);
-	new_record[Anum_pg_database_datname - 1] =
-		DirectFunctionCall1(namein, CStringGetDatum(dbname));
-	new_record[Anum_pg_database_datdba - 1] = ObjectIdGetDatum(datdba);
-	new_record[Anum_pg_database_encoding - 1] = Int32GetDatum(encoding);
-	new_record[Anum_pg_database_datlocprovider - 1] = CharGetDatum(dblocprovider);
-	new_record[Anum_pg_database_datistemplate - 1] = BoolGetDatum(dbistemplate);
-	new_record[Anum_pg_database_datallowconn - 1] = BoolGetDatum(dballowconnections);
-	new_record[Anum_pg_database_dathasloginevt - 1] = BoolGetDatum(src_hasloginevt);
-	new_record[Anum_pg_database_datconnlimit - 1] = Int32GetDatum(dbconnlimit);
-	new_record[Anum_pg_database_datfrozenxid - 1] = TransactionIdGetDatum(src_frozenxid);
-	new_record[Anum_pg_database_datminmxid - 1] = TransactionIdGetDatum(src_minmxid);
-	new_record[Anum_pg_database_dattablespace - 1] = ObjectIdGetDatum(dst_deftablespace);
-	new_record[Anum_pg_database_datcollate - 1] = CStringGetTextDatum(dbcollate);
-	new_record[Anum_pg_database_datctype - 1] = CStringGetTextDatum(dbctype);
+	HeapTupleSetValue(pg_database, oid, ObjectIdGetDatum(dboid), values);
+	HeapTupleSetValue(pg_database, datname, DirectFunctionCall1(namein, CStringGetDatum(dbname)), values);
+	HeapTupleSetValue(pg_database, datdba, ObjectIdGetDatum(datdba), values);
+	HeapTupleSetValue(pg_database, encoding, Int32GetDatum(encoding), values);
+	HeapTupleSetValue(pg_database, datlocprovider, CharGetDatum(dblocprovider), values);
+	HeapTupleSetValue(pg_database, datistemplate, BoolGetDatum(dbistemplate), values);
+	HeapTupleSetValue(pg_database, datallowconn, BoolGetDatum(dballowconnections), values);
+	HeapTupleSetValue(pg_database, dathasloginevt, BoolGetDatum(src_hasloginevt), values);
+	HeapTupleSetValue(pg_database, datconnlimit, Int32GetDatum(dbconnlimit), values);
+	HeapTupleSetValue(pg_database, datfrozenxid, TransactionIdGetDatum(src_frozenxid), values);
+	HeapTupleSetValue(pg_database, datminmxid, TransactionIdGetDatum(src_minmxid), values);
+	HeapTupleSetValue(pg_database, dattablespace, ObjectIdGetDatum(dst_deftablespace), values);
+	HeapTupleSetValue(pg_database, datcollate, CStringGetTextDatum(dbcollate), values);
+	HeapTupleSetValue(pg_database, datctype, CStringGetTextDatum(dbctype), values);
 	if (dblocale)
-		new_record[Anum_pg_database_datlocale - 1] = CStringGetTextDatum(dblocale);
+		HeapTupleSetValue(pg_database, datlocale, CStringGetTextDatum(dblocale), values);
 	else
-		new_record_nulls[Anum_pg_database_datlocale - 1] = true;
+		HeapTupleSetValueNull(pg_database, datlocale, values, nulls);
 	if (dbicurules)
-		new_record[Anum_pg_database_daticurules - 1] = CStringGetTextDatum(dbicurules);
+		HeapTupleSetValue(pg_database, daticurules, CStringGetTextDatum(dbicurules), values);
 	else
-		new_record_nulls[Anum_pg_database_daticurules - 1] = true;
+		HeapTupleSetValueNull(pg_database, daticurules, values, nulls);
 	if (dbcollversion)
-		new_record[Anum_pg_database_datcollversion - 1] = CStringGetTextDatum(dbcollversion);
+		HeapTupleSetValue(pg_database, datcollversion, CStringGetTextDatum(dbcollversion), values);
 	else
-		new_record_nulls[Anum_pg_database_datcollversion - 1] = true;
+		HeapTupleSetValueNull(pg_database, datcollversion, values, nulls);
 
 	/*
 	 * We deliberately set datacl to default (NULL), rather than copying it
 	 * from the template database.  Copying it would be a bad idea when the
 	 * owner is not the same as the template's owner.
 	 */
-	new_record_nulls[Anum_pg_database_datacl - 1] = true;
+	HeapTupleSetValueNull(pg_database, datacl, values, nulls);
 
 	tuple = heap_form_tuple(RelationGetDescr(pg_database_rel),
-							new_record, new_record_nulls);
+							values, nulls);
 
-	CatalogTupleInsert(pg_database_rel, tuple);
+	CatalogTupleInsert(pg_database_rel, tuple, NULL);
 
 	/*
 	 * Now generate additional catalog entries associated with the new DB
@@ -1909,6 +1908,7 @@ RenameDatabase(const char *oldname, const char *newname)
 	int			notherbackends;
 	int			npreparedxacts;
 	ObjectAddress address;
+	Bitmapset  *updated = NULL;
 
 	/*
 	 * Look up the target database's OID, and get exclusive lock on it. We
@@ -1980,8 +1980,9 @@ RenameDatabase(const char *oldname, const char *newname)
 	if (!HeapTupleIsValid(newtup))
 		elog(ERROR, "cache lookup failed for database %u", db_id);
 	otid = newtup->t_self;
-	namestrcpy(&(((Form_pg_database) GETSTRUCT(newtup))->datname), newname);
-	CatalogTupleUpdate(rel, &otid, newtup);
+	namestrcpy(&((Form_pg_database) GETSTRUCT(newtup))->datname, newname);
+	HeapTupleMarkColumnUpdated(pg_database, datname, updated);
+	CatalogTupleUpdate(rel, &otid, newtup, updated, NULL);
 	UnlockTuple(rel, &otid, InplaceUpdateTupleLock);
 
 	InvokeObjectPostAlterHook(DatabaseRelationId, db_id, 0);
@@ -1992,6 +1993,7 @@ RenameDatabase(const char *oldname, const char *newname)
 	 * Close pg_database, but keep lock till commit.
 	 */
 	table_close(rel, NoLock);
+	bms_free(updated);
 
 	return address;
 }
@@ -2189,9 +2191,9 @@ movedb(const char *dbname, const char *tblspcname)
 	PG_ENSURE_ERROR_CLEANUP(movedb_failure_callback,
 							PointerGetDatum(&fparms));
 	{
-		Datum		new_record[Natts_pg_database] = {0};
-		bool		new_record_nulls[Natts_pg_database] = {0};
-		bool		new_record_repl[Natts_pg_database] = {0};
+		Datum		values[Natts_pg_database] = {0};
+		bool		nulls[Natts_pg_database] = {false};
+		Bitmapset  *updated = NULL;
 
 		/*
 		 * Copy files from the old tablespace to the new one
@@ -2233,13 +2235,10 @@ movedb(const char *dbname, const char *tblspcname)
 					 errmsg("database \"%s\" does not exist", dbname)));
 		LockTuple(pgdbrel, &oldtuple->t_self, InplaceUpdateTupleLock);
 
-		new_record[Anum_pg_database_dattablespace - 1] = ObjectIdGetDatum(dst_tblspcoid);
-		new_record_repl[Anum_pg_database_dattablespace - 1] = true;
+		HeapTupleUpdateValue(pg_database, dattablespace, ObjectIdGetDatum(dst_tblspcoid), values, nulls, updated);
 
-		newtuple = heap_modify_tuple(oldtuple, RelationGetDescr(pgdbrel),
-									 new_record,
-									 new_record_nulls, new_record_repl);
-		CatalogTupleUpdate(pgdbrel, &oldtuple->t_self, newtuple);
+		newtuple = heap_update_tuple(oldtuple, RelationGetDescr(pgdbrel), values, nulls, updated);
+		CatalogTupleUpdate(pgdbrel, &oldtuple->t_self, newtuple, updated, NULL);
 		UnlockTuple(pgdbrel, &oldtuple->t_self, InplaceUpdateTupleLock);
 
 		InvokeObjectPostAlterHook(DatabaseRelationId, db_id, 0);
@@ -2267,6 +2266,7 @@ movedb(const char *dbname, const char *tblspcname)
 		 * Close pg_database, but keep lock till commit.
 		 */
 		table_close(pgdbrel, NoLock);
+		bms_free(updated);
 	}
 	PG_END_ENSURE_ERROR_CLEANUP(movedb_failure_callback,
 								PointerGetDatum(&fparms));
@@ -2383,9 +2383,9 @@ AlterDatabase(ParseState *pstate, AlterDatabaseStmt *stmt, bool isTopLevel)
 	DefElem    *dallowconnections = NULL;
 	DefElem    *dconnlimit = NULL;
 	DefElem    *dtablespace = NULL;
-	Datum		new_record[Natts_pg_database] = {0};
-	bool		new_record_nulls[Natts_pg_database] = {0};
-	bool		new_record_repl[Natts_pg_database] = {0};
+	Datum		values[Natts_pg_database] = {0};
+	bool		nulls[Natts_pg_database] = {false};
+	Bitmapset  *updated = NULL;
 
 	/* Extract options from the statement node tree */
 	foreach(option, stmt->options)
@@ -2504,24 +2504,16 @@ AlterDatabase(ParseState *pstate, AlterDatabaseStmt *stmt, bool isTopLevel)
 	 * Build an updated tuple, perusing the information just obtained
 	 */
 	if (distemplate)
-	{
-		new_record[Anum_pg_database_datistemplate - 1] = BoolGetDatum(dbistemplate);
-		new_record_repl[Anum_pg_database_datistemplate - 1] = true;
-	}
+		HeapTupleUpdateValue(pg_database, datistemplate, BoolGetDatum(dbistemplate), values, nulls, updated);
+
 	if (dallowconnections)
-	{
-		new_record[Anum_pg_database_datallowconn - 1] = BoolGetDatum(dballowconnections);
-		new_record_repl[Anum_pg_database_datallowconn - 1] = true;
-	}
+		HeapTupleUpdateValue(pg_database, datallowconn, BoolGetDatum(dballowconnections), values, nulls, updated);
+
 	if (dconnlimit)
-	{
-		new_record[Anum_pg_database_datconnlimit - 1] = Int32GetDatum(dbconnlimit);
-		new_record_repl[Anum_pg_database_datconnlimit - 1] = true;
-	}
+		HeapTupleUpdateValue(pg_database, datconnlimit, Int32GetDatum(dbconnlimit), values, nulls, updated);
 
-	newtuple = heap_modify_tuple(tuple, RelationGetDescr(rel), new_record,
-								 new_record_nulls, new_record_repl);
-	CatalogTupleUpdate(rel, &tuple->t_self, newtuple);
+	newtuple = heap_update_tuple(tuple, RelationGetDescr(rel), values, nulls, updated);
+	CatalogTupleUpdate(rel, &tuple->t_self, newtuple, updated, NULL);
 	UnlockTuple(rel, &tuple->t_self, InplaceUpdateTupleLock);
 
 	InvokeObjectPostAlterHook(DatabaseRelationId, dboid, 0);
@@ -2530,6 +2522,7 @@ AlterDatabase(ParseState *pstate, AlterDatabaseStmt *stmt, bool isTopLevel)
 
 	/* Close pg_database, but keep lock till commit */
 	table_close(rel, NoLock);
+	bms_free(updated);
 
 	return dboid;
 }
@@ -2598,22 +2591,21 @@ AlterDatabaseRefreshColl(AlterDatabaseRefreshCollStmt *stmt)
 		elog(ERROR, "invalid collation version change");
 	else if (oldversion && newversion && strcmp(newversion, oldversion) != 0)
 	{
-		bool		nulls[Natts_pg_database] = {0};
-		bool		replaces[Natts_pg_database] = {0};
 		Datum		values[Natts_pg_database] = {0};
+		bool		nulls[Natts_pg_database] = {false};
+		Bitmapset  *updated = NULL;
 		HeapTuple	newtuple;
 
 		ereport(NOTICE,
 				(errmsg("changing version from %s to %s",
 						oldversion, newversion)));
 
-		values[Anum_pg_database_datcollversion - 1] = CStringGetTextDatum(newversion);
-		replaces[Anum_pg_database_datcollversion - 1] = true;
+		HeapTupleUpdateValue(pg_database, datcollversion, CStringGetTextDatum(newversion), values, nulls, updated);
 
-		newtuple = heap_modify_tuple(tuple, RelationGetDescr(rel),
-									 values, nulls, replaces);
-		CatalogTupleUpdate(rel, &tuple->t_self, newtuple);
+		newtuple = heap_update_tuple(tuple, RelationGetDescr(rel), values, nulls, updated);
+		CatalogTupleUpdate(rel, &tuple->t_self, newtuple, updated, NULL);
 		heap_freetuple(newtuple);
+		bms_free(updated);
 	}
 	else
 		ereport(NOTICE,
@@ -2700,9 +2692,9 @@ AlterDatabaseOwner(const char *dbname, Oid newOwnerId)
 	 */
 	if (datForm->datdba != newOwnerId)
 	{
-		Datum		repl_val[Natts_pg_database];
-		bool		repl_null[Natts_pg_database] = {0};
-		bool		repl_repl[Natts_pg_database] = {0};
+		Datum		values[Natts_pg_database] = {0};
+		bool		nulls[Natts_pg_database] = {false};
+		Bitmapset  *updated = NULL;
 		Acl		   *newAcl;
 		Datum		aclDatum;
 		bool		isNull;
@@ -2732,8 +2724,7 @@ AlterDatabaseOwner(const char *dbname, Oid newOwnerId)
 
 		LockTuple(rel, &tuple->t_self, InplaceUpdateTupleLock);
 
-		repl_repl[Anum_pg_database_datdba - 1] = true;
-		repl_val[Anum_pg_database_datdba - 1] = ObjectIdGetDatum(newOwnerId);
+		HeapTupleUpdateValue(pg_database, datdba, ObjectIdGetDatum(newOwnerId), values, nulls, updated);
 
 		/*
 		 * Determine the modified ACL for the new owner.  This is only
@@ -2747,18 +2738,18 @@ AlterDatabaseOwner(const char *dbname, Oid newOwnerId)
 		{
 			newAcl = aclnewowner(DatumGetAclP(aclDatum),
 								 datForm->datdba, newOwnerId);
-			repl_repl[Anum_pg_database_datacl - 1] = true;
-			repl_val[Anum_pg_database_datacl - 1] = PointerGetDatum(newAcl);
+			HeapTupleUpdateValue(pg_database, datacl, PointerGetDatum(newAcl), values, nulls, updated);
 		}
 
-		newtuple = heap_modify_tuple(tuple, RelationGetDescr(rel), repl_val, repl_null, repl_repl);
-		CatalogTupleUpdate(rel, &newtuple->t_self, newtuple);
+		newtuple = heap_update_tuple(tuple, RelationGetDescr(rel), values, nulls, updated);
+		CatalogTupleUpdate(rel, &newtuple->t_self, newtuple, updated, NULL);
 		UnlockTuple(rel, &tuple->t_self, InplaceUpdateTupleLock);
 
 		heap_freetuple(newtuple);
 
 		/* Update owner dependency reference */
 		changeDependencyOnOwner(DatabaseRelationId, db_id, newOwnerId);
+		bms_free(updated);
 	}
 
 	InvokeObjectPostAlterHook(DatabaseRelationId, db_id, 0);
diff --git a/src/backend/commands/event_trigger.c b/src/backend/commands/event_trigger.c
index 028f9e2de90..e7d69176ce7 100644
--- a/src/backend/commands/event_trigger.c
+++ b/src/backend/commands/event_trigger.c
@@ -280,8 +280,8 @@ insert_event_trigger_tuple(const char *trigname, const char *eventname, Oid evtO
 	Relation	tgrel;
 	Oid			trigoid;
 	HeapTuple	tuple;
-	Datum		values[Natts_pg_event_trigger];
-	bool		nulls[Natts_pg_event_trigger];
+	Datum		values[Natts_pg_event_trigger] = {0};
+	bool		nulls[Natts_pg_event_trigger] = {false};
 	NameData	evtnamedata,
 				evteventdata;
 	ObjectAddress myself,
@@ -293,25 +293,23 @@ insert_event_trigger_tuple(const char *trigname, const char *eventname, Oid evtO
 	/* Build the new pg_trigger tuple. */
 	trigoid = GetNewOidWithIndex(tgrel, EventTriggerOidIndexId,
 								 Anum_pg_event_trigger_oid);
-	values[Anum_pg_event_trigger_oid - 1] = ObjectIdGetDatum(trigoid);
+	HeapTupleSetValue(pg_event_trigger, oid, ObjectIdGetDatum(trigoid), values);
 	memset(nulls, false, sizeof(nulls));
 	namestrcpy(&evtnamedata, trigname);
-	values[Anum_pg_event_trigger_evtname - 1] = NameGetDatum(&evtnamedata);
+	HeapTupleSetValue(pg_event_trigger, evtname, NameGetDatum(&evtnamedata), values);
 	namestrcpy(&evteventdata, eventname);
-	values[Anum_pg_event_trigger_evtevent - 1] = NameGetDatum(&evteventdata);
-	values[Anum_pg_event_trigger_evtowner - 1] = ObjectIdGetDatum(evtOwner);
-	values[Anum_pg_event_trigger_evtfoid - 1] = ObjectIdGetDatum(funcoid);
-	values[Anum_pg_event_trigger_evtenabled - 1] =
-		CharGetDatum(TRIGGER_FIRES_ON_ORIGIN);
+	HeapTupleSetValue(pg_event_trigger, evtevent, NameGetDatum(&evteventdata), values);
+	HeapTupleSetValue(pg_event_trigger, evtowner, ObjectIdGetDatum(evtOwner), values);
+	HeapTupleSetValue(pg_event_trigger, evtfoid, ObjectIdGetDatum(funcoid), values);
+	HeapTupleSetValue(pg_event_trigger, evtenabled, CharGetDatum(TRIGGER_FIRES_ON_ORIGIN), values);
 	if (taglist == NIL)
-		nulls[Anum_pg_event_trigger_evttags - 1] = true;
+		HeapTupleSetValueNull(pg_event_trigger, evttags, values, nulls);
 	else
-		values[Anum_pg_event_trigger_evttags - 1] =
-			filter_list_to_array(taglist);
+		HeapTupleSetValue(pg_event_trigger, evttags, filter_list_to_array(taglist), values);
 
 	/* Insert heap tuple. */
 	tuple = heap_form_tuple(tgrel->rd_att, values, nulls);
-	CatalogTupleInsert(tgrel, tuple);
+	CatalogTupleInsert(tgrel, tuple, NULL);
 	heap_freetuple(tuple);
 
 	/*
@@ -394,6 +392,7 @@ SetDatabaseHasLoginEventTriggers(void)
 	Relation	pg_db = table_open(DatabaseRelationId, RowExclusiveLock);
 	ItemPointerData otid;
 	HeapTuple	tuple;
+	Bitmapset  *updated = NULL;
 
 	/*
 	 * Use shared lock to prevent a conflict with EventTriggerOnLogin() trying
@@ -411,8 +410,9 @@ SetDatabaseHasLoginEventTriggers(void)
 	db = (Form_pg_database) GETSTRUCT(tuple);
 	if (!db->dathasloginevt)
 	{
-		db->dathasloginevt = true;
-		CatalogTupleUpdate(pg_db, &otid, tuple);
+		HeapTupleUpdateField(pg_database, dathasloginevt, true, db, updated);
+		CatalogTupleUpdate(pg_db, &otid, tuple, updated, NULL);
+		bms_free(updated);
 		CommandCounterIncrement();
 	}
 	UnlockTuple(pg_db, &otid, InplaceUpdateTupleLock);
@@ -431,6 +431,7 @@ AlterEventTrigger(AlterEventTrigStmt *stmt)
 	Oid			trigoid;
 	Form_pg_event_trigger evtForm;
 	char		tgenabled = stmt->tgenabled;
+	Bitmapset  *updated = NULL;
 
 	tgrel = table_open(EventTriggerRelationId, RowExclusiveLock);
 
@@ -450,9 +451,10 @@ AlterEventTrigger(AlterEventTrigStmt *stmt)
 					   stmt->trigname);
 
 	/* tuple is a copy, so we can modify it below */
-	evtForm->evtenabled = tgenabled;
+	HeapTupleUpdateField(pg_event_trigger, evtenabled, tgenabled, evtForm, updated);
 
-	CatalogTupleUpdate(tgrel, &tup->t_self, tup);
+	CatalogTupleUpdate(tgrel, &tup->t_self, tup, updated, NULL);
+	bms_free(updated);
 
 	/*
 	 * Login event triggers have an additional flag in pg_database to enable
@@ -539,6 +541,7 @@ static void
 AlterEventTriggerOwner_internal(Relation rel, HeapTuple tup, Oid newOwnerId)
 {
 	Form_pg_event_trigger form;
+	Bitmapset  *updated = NULL;
 
 	form = (Form_pg_event_trigger) GETSTRUCT(tup);
 
@@ -557,8 +560,9 @@ AlterEventTriggerOwner_internal(Relation rel, HeapTuple tup, Oid newOwnerId)
 						NameStr(form->evtname)),
 				 errhint("The owner of an event trigger must be a superuser.")));
 
-	form->evtowner = newOwnerId;
-	CatalogTupleUpdate(rel, &tup->t_self, tup);
+	HeapTupleUpdateField(pg_event_trigger, evtowner, newOwnerId, form, updated);
+	CatalogTupleUpdate(rel, &tup->t_self, tup, updated, NULL);
+	bms_free(updated);
 
 	/* Update owner dependency reference */
 	changeDependencyOnOwner(EventTriggerRelationId,
